
// BeauGaugeExample027Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "BeauGaugeExample027.h"
#include "BeauGaugeExample027Dlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CBeauGaugeExample027Dlg dialog




CBeauGaugeExample027Dlg::CBeauGaugeExample027Dlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CBeauGaugeExample027Dlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBeauGaugeExample027Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	for(int i = 0 ; i < 5 ; i++ )
	{
		DDX_Control(pDX, IDC_BGV6ACTIVEXCTRLTRIAL1 + i, m_gauge[i]);
	}
}

BEGIN_MESSAGE_MAP(CBeauGaugeExample027Dlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, &CBeauGaugeExample027Dlg::OnBnClickedButton1)
	ON_WM_DESTROY()
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CBeauGaugeExample027Dlg message handlers

BOOL CBeauGaugeExample027Dlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	SetTimer(1,1,NULL);
	SetTimer(2,500,NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBeauGaugeExample027Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBeauGaugeExample027Dlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBeauGaugeExample027Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CBeauGaugeExample027Dlg::OnBnClickedButton1()
{
	m_gauge[0].AboutBox();
}


void CBeauGaugeExample027Dlg::OnDestroy()
{
	CDialogEx::OnDestroy();

	KillTimer(1);
	KillTimer(2);
}


void CBeauGaugeExample027Dlg::OnTimer(UINT_PTR nIDEvent)
{
	if(1 == nIDEvent)
	{
		static int nValue = 0;
		m_gauge[0].SetValue(_T("Pointer1"),nValue);
		m_gauge[4].SetValue(_T("Pointer1"),nValue);
		nValue++;
		if(nValue>100)
			nValue = 0;
	}

	if(2 == nIDEvent)
	{
		static BOOL b1 = TRUE;
		m_gauge[3].SetValue(_T("ImageStateIndicator1"),b1);
		b1 = !b1;
	}

	CDialogEx::OnTimer(nIDEvent);
}
